//Fichier .h commun  tous les fichiers source...

#ifndef COMMUN_H
#define COMMUN_H

#include <mygba.h>
#include "Res/all.h"
#include "materiel.h"
#include <stdio.h>
#include "routines.h"
#include "filesystem.h"
#include "son.h"

//grotablo.c
extern const u32 Verdana_fonte[];
extern const u32 Verdana_masque[];
extern const u32 Verdana_tailles[];
extern const u32 Verdana_hauteur;
extern const u32 Verdana_fonte256[];
extern const u32 Verdana_masque256[];
extern const u32 Verdana_largeur;

extern const u32 Moyenne_fonte[];
extern const u32 Moyenne_masque[];
extern const u32 Moyenne_tailles[];
extern const u32 Moyenne_hauteur;

extern const u32 Arial_fonte[];
extern const u32 Arial_masque[];
extern const u32 Arial_tailles[];
extern const u32 Arial_hauteur;

//Pour les appels lointains (IWRAM <-> ROM)
void (*pRoutineLointaine)();
u32 (*pFctLointaine)();
#define Exec(a,b...) ({ pRoutineLointaine = (void*)(a); pRoutineLointaine(b); })
#define ExecFct(a,b...) ({ pFctLointaine = (void*)(a); pFctLointaine(b); })

typedef u8 BOOL;
//Taille du texte dessin (en hauteur) par la fonction DessTexteWW
extern u32 y_ww;
//Pour le dfilement. Utilis au dbut pour l'aide mais plus maintenant.
char *ligne2;
//Numro de frame (image) pour les animations qui en dpendent (effets de transition, palette, etc.)
extern int nFrame;
//Action  effectuer (lors d'un reset systme)
extern u32 action, ancienRegTouches;
//Savoir si un FadeIn a t excut avant de pouvoir faire un FadeOut.
extern u32 fade_actif;

//Efface un ScreenBlock (map) entier.
void EffaceScreenBlock(u32 screenBlock);

//L'cran devient progressivement noir
void FadeIn();
//Et avec a il redevient progressivement normal.
void FadeOut();


//Le curseur contient les infos qui y sont relatives
typedef struct      {
    int x,y, no_sprite;                 //Positions, numro de sprite associ
    int l,h;                            //Largeur et hauteur courante
    const unsigned char *tiles;         //Tiles (mosaques) associes, pour le sprite
} CURSEUR;

//L'lment "fonction" est inutilis, mais pourrait tre utile pour certains lments.
typedef struct      {
    char *titre;
    char *texte;
    unsigned char *(*fonction)();
} EVENEMENT;

extern int couleurs[8][3];
//Change les couleurs de la bote de dialogue.
void ChangeCouleursBteDialogue();
//Affiche un menu permettant de choisir une option
int SelectionneProjet(CURSEUR *c, const EVENEMENT *ev);

CURSEUR *gblCurs;

extern int numero_musique, bCPUMetre, bTransp;
extern int nFrame;

#include "texte.h"
#include "lecteur.h"
#include "menu_couleurs.h"
#include "sram.h"

#endif /* COMMUN_H */


/* END OF FILE */

