//Numro de sprite utilis pour la bote de dialogue.
int num_spr_dialogue;
int bCPUMetre=0, bTransp=1;

//Les informations sont composes d'une zone et d'un identificateur (n) d'vnement.
typedef struct      {
    u32 x0,y0,x1,y1,event;
} INFO;

#include "menupause.h"

//Evenement spcial pour le menu pause
EVENEMENT evPause=      {
    "Menu pause",
    "#|Reprendre la partie#Reprendre\n#|Changer les couleurs de l'environnement#Menu couleurs...\n   Musique: #|Active ou non la musique#\n   Bruitages: #|Active ou non les bruitages#\n   Morceau: #|Faites votre choix#\n   CPU-Mtre: #|Affiche l'utilisation du processeur#",
    FctMenuPause,
};

//Contient la liste des zones d'informations et les vnements gnrs par le programme  Zanella.
#include "zones.h"


//Teste  l'endroit o se trouve le curseur c s'il y a une bote d'information qui s'y trouve et retourne,
//le cas chant, un pointeur sur celle-ci. On la dessinera par la suite.
INFO *TesteInfos(CURSEUR *c)       {
    u32 i;
    //Pour toutes les infos existantes
    for (i=0;i<sizeof(infos)/sizeof(infos[0]);i++)      {
        //Teste si le curseur se trouve dans le rectangle de la bote d'infos
        if (c->x>=infos[i].x0 && c->x<=infos[i].x1 && c->y>=infos[i].y0 && c->y<=infos[i].y1)
            //On est sur cette info-ci.
            return (INFO*)&infos[i];
    }
    //Aucune info trouve
    return NULL;
}

// Utilise par AffichePoints.
void Affiche1Point(s32 x, s32 y, u8 type, BOOL select)       {
    //Cre un nouvel objet
    CreeObjetStandard(AjouteSprite(point_tiles+16*8*select,16*16),1,TAILLE_16x16);
    PlaceObjetEx(objetsUtilises,x,y);
}

//Affiche tous les points (objets ronds) visibles sur l'cran, indiquant une bote d'infos.
BOOL AffichePoints(CURSEUR *c, ECRAN *e, INFO *selection)        {
    u32 i;
    s32 x,y, x_point, y_point;
    BOOL select=FALSE;

    //Pour toutes les infos disponibles
    for (i=0;i<sizeof(infos)/sizeof(infos[0]);i++)      {
        //On trouve le point milieu
        x_point=((infos[i].x0+infos[i].x1)>>1)-8;
        y_point=((infos[i].y0+infos[i].y1)>>1)-8;
        //On y soustrait la position de l'cran pour trouver la position relative
        x=x_point-e->x;
        y=y_point-e->y;
        //Si le point est contenu dans l'cran
        if (x>=-16 && x<240 && y>=-16 && y<160)         {
            //Si c'est le point slectionn
            if (selection==&infos[i])       {
                //On l'affiche avec des tiles diffrentes utilisant une palette clignotante
                Affiche1Point(x,y,0,1);
                select=TRUE;
            }
            else
                //Sinon avec la palette de base (bleue, normale)
                Affiche1Point(x,y,0,0);
        }
    }
    //Retourne si oui ou non une slection est faite. Permet de savoir s'il y a besoin de mettre  jour l'affichage.
    return select;
}

//Initialise le systme de bote de dialogue, principalement en initialisant le sprite transparent et en
//rotation de celle-ci.
void InitBteDialogue()      {
    int i;
    //Voir mon systme de sprites (sprites.h)
    i=AjouteSprite(noir_tiles,64*64*2);
    //Fonction spciale de sprites.h juste prvue pour cela (modification de CreeObjetStandard).
//    CopieDMA((void*)noir_palette,nPalObj(2),16,DMA_16im);
    CreeBoite(i,TAILLE_64x64);
    //On la place  l'endroit par dfaut
    PlaceObjetXY(objetsUtilises,14*8,3*8);
    //On initialise le rotset n 0 (qu'utilise ce sprite)
    rotData[0].pb=0;                            //dmx } ces paramtres ne sont utiliss que pour la rota-
    rotData[0].pc=0;                            //dmy } tion. Le redimensionnement n'utilise que dx et dy.
    //On garde une trace (globale) du numro de sprite tant donn qu'on va y accder depuis un peu partout.
    num_spr_dialogue=objetsUtilises;
}

//Dplace la bote de dialogue.
void PlaceBteDialogue(u32 x, u32 y)      {
    //Il faut non seulement dplacer le sprite ...
    PlaceObjetEx(num_spr_dialogue,x,y-(64-y_ww)/2-32);
    //... mais aussi tout le BG1. On le fait en modifiant les valeurs du dfilement.
    REG_BG1HOFS=-x, REG_BG1VOFS=-y;
}

//Endroit actuel o se trouve la bote de dialogue
u32 endroit_x, endroit_y;

//Gestion de la bote de dialogue en fonction du curseur, de la position voulue et de l'cran. Permet que
//les deux ne s'crasent pas mutuelement. Le paramtre set permet de dfinir la position tant donn que
//la fonction va amortir le mouvement au cas o il est trs brusque (c'est plus joli).
void PlacementBteDialogue(CURSEUR *c, ECRAN *e, BOOL set)       {
    //Amplitude de mouvement  chaque cycle
    const u32 amplitude=8;
    u32 i;
    //Positions actuelles, sauves.
    static int cur_x=0, cur_y=0;
    s32 x, y;

    //Calcule la position idale
    y=c->y-e->y+c->h+5;
    x=c->x-e->x-64+c->l/2;
    //Hors de l'cran -> on la met ailleurs...
    if (x<0)            x=0;
    if (x+128>=240)     x=240-128;
    if (y+y_ww>=150)        {
        y=c->y-e->y-y_ww-5;
    }
    if (y<0)            y=0;

    //Pas de dplacement fluide dans ce cas (initialisation)
    if (set)
        cur_x=x, cur_y=y;

    for (i=0;i<amplitude;i++)           {
        //Dplace lentement la bote vers son objectif
        if (x>cur_x)
            cur_x++;
        if (x<cur_x)
            cur_x--;
        if (y>cur_y)
            cur_y++;
        if (y<cur_y)
            cur_y--;
    }
    //Et voil.
    PlaceBteDialogue(cur_x,cur_y);
    //Il faut garder ces valeurs en tant que globales.
    endroit_x=cur_x, endroit_y=cur_y;
}

//Informations sur la zone de texte zt_infos
ZONE_TEXTE zt_infos={buffer_infos,16,10};
int gblOffset=0;

//Dessine la bote d'informations. Utilise une couleur diffrente pour le projet slectionn (n ID = selection).
void DessineInfo(const EVENEMENT *ev, s32 selection)        {
    static int taille_max=0;
    
    //En fonte moyenne
    ChangeFonte(Moyenne);
    //Avec la zone de texte zt_infos
    SelectZoneTexte(&zt_infos);
    //Effacement de la zone
    EffaceZone(&zt_infos);
    //Dessine le titre
    DessTexte(0,0,ev->titre,2);
    //Deux fois pour donner un effet de gras
    DessTexte(1,0,ev->titre,2);
    //Maintenant en Arial (plus petite)
    ChangeFonte(Arial);

    //Commenter ces deux lignes pour dsactiver la pranalyse du menu. Dans la majorit des cas, cela
    //fonctionnera sans problme (sauf dans le cas de menus  handlers avec des options changeant
    //subitement de taille lorsqu'elles sont slectionnes). Cela permet d'conomiser un temps CPU
    //non ngligeable!
    DessTexteSpecial(2,13,ev->texte,3,-1,0,ev->fonction,0);
    taille_max=y_ww;

    /*
        Cette partie dtermine le meilleur scrolling (gblOffset) possible selon la slection active.
        Normalement, quatre lignes suffiraient pour des menus basiques, mais avec le support de texte
        statique au sommet et  la fin de la bote qui devrait toujours tre visible et que tous les cas
        que j'ai pu imaginer sont supports, le code est lgrement plus long.
        Si vous souhaitez le modifier et que vous ne le comprenez vraiment pas, alors mieux vaut le
        rcrire vous-mme!
    */
    //Pas de slection -> affichage de la premire ligne
    if (selection<0)
        gblOffset=0;
    //Premier lien slectionn
    else if (selection==0)            {
        //Dans la mesure du possible, on affiche le texte au sommet
        gblOffset=0;
        //Et si la taille du texte au sommet + le lien slectionn > hauteur de la bote, on fait dfiler
        //la bote pour voir au moins entirement le lien.
        while (liens[selection].yfin>=64+gblOffset)
            gblOffset+=hauteur_texte;
    }
    //Dernire option slectionne
    else if (selection==nEvenement-1)      {
        //Place le dfilement de manire  voir le texte jusqu' la dernire ligne.
        while(taille_max+hauteur_texte>=64+gblOffset)
            gblOffset+=hauteur_texte;
        //Mais si cela ne permet pas de voir le lien entirement (i.e. il est plus haut que le sommet de
        //la bote), on remonte le dfilement. La priorit est toujours qu'on voie le lien slectionn!
        while (liens[selection].y<=13+gblOffset-hauteur_texte)
            gblOffset-=hauteur_texte;
    }
    //Une option du milieu est slectionne
    else    {
        while(1)        {
            //Contrle si les deux conditions sont vraies (ce qui provoquerait un plantage), c'est--dire
            //que le fond du texte est en-dessous de la barre et le sommet en-dessus galement. Comme il y
            //a trois lignes entre-deux, on teste >3*hauteur_texte.
            if (liens[selection].yfin-liens[selection].y>3*hauteur_texte)       {
                //Le lien fait 4 lignes ou plus -> align sur le haut
                gblOffset=liens[selection].y-13;
                break;
            }
            //Fond du lien plus bas que la quatrime ligne -> dfilement sur le haut
            else if (liens[selection].yfin+hauteur_texte>=64+gblOffset)
                gblOffset+=hauteur_texte;
            //Sommet du lien plus haut que la deuxime ligne -> dfilement sur le bas
            else if (liens[selection].y<=13+gblOffset)
                gblOffset-=hauteur_texte;
            //Plus aucun problme.
            else
                break;
        }
    }
    //La dernire ligne doit toujours se trouver au fond!
    while (taille_max-gblOffset+2*hauteur_texte<64)
        gblOffset-=hauteur_texte;
    //Mais la premire doit aussi toujours se trouver au sommet... et c'est quand-mme une priorit.
    if (gblOffset<0)
        gblOffset=0;

    ChangeFonte(Arial);
    //Dessine le texte avec le lien slectionn
    DessTexteSpecial(2,13,ev->texte,3,selection,gblOffset,ev->fonction,1);

    //Permet de connatre la taille totale de la zone de texte (ce paramtre est modifi par la fonction ci-dessus).
    taille_max=y_ww;
    //Hauteur de la bote de dialogue.
    if (y_ww+hauteur_texte>64)
        y_ww=14+5*hauteur_texte;                //Pas plus grande que 64 de toutes faons!
    else
        y_ww+=hauteur_texte+1;                  //Mais peut-tre plus petite.
}

//Comme dans la boucle principale
int BougeMain(int no_obj, int x, int y, int vitesse);
void Main_EffetsPalette();
#define EffaceBufferDebug()  MemSet(&zero,(void*)CharBaseBlock(3)+32,sizeof(buffer_debug)>>1,DMA_16im)

int PlaceMiniMessage(int actif)             {
    static int posY=0;
    int ancY=posY;
    
    if (actif)      {
        if (posY<11)
            posY++;
    }
    else    {
        if (posY>0)
            posY--;
    }
    
    if (posY!=ancY)                     //La position a chang?
        REG_BG3VOFS=-160+posY;          //On crit sur l'arrire-plan
    return posY;
}

void ChangeCouleursBteDialogue()         {
    int rsrc=couleurs[0][0], vsrc=couleurs[0][1], bsrc=couleurs[0][2];
    int rdst=couleurs[1][0], vdst=couleurs[1][1], bdst=couleurs[1][2];
    int i,j;
    
    for (i=0;i<32;i++)          {
        j=32-i;
        PaletteObj[32+i]=RGB((i*rdst+j*rsrc)>>5,(i*vdst+j*vsrc)>>5,(i*bdst+j*bsrc)>>5);
    }
    Palette[195]=RGB(couleurs[2][0],couleurs[2][1],couleurs[2][2]);
    Palette[194]=RGB(couleurs[3][0],couleurs[3][1],couleurs[3][2]);
    Palette[197]=RGB(couleurs[6][0],couleurs[6][1],couleurs[6][2]);
    Palette[193]=RGB(couleurs[7][0],couleurs[7][1],couleurs[7][2]);
}

int lastnEv=0;

//Affiche et gre le menu de slection des projets.
int SelectionneProjet(CURSEUR *c, const EVENEMENT *ev)            {
    //Numro d'vnement slectionn
    int nEv=0, activite_message=0;
    //Mini-systme de gestion des touches meilleur que la lecture  bas niveau.
    int bien_place=0, TOUCHES, repete=0;
    u32 zero=0x11111111;
    int i;

    //Dans le cas d'une mise  jour du slecteur de projet, on doit laisser la slection  son tat actuel, sinon la rinitialiser.
    if (action==1)
        nEv=lastnEv;

    //Retourne la main
    RetourneObjetH_Oui(c->no_sprite);
    
    gblCurs=c;

    //Il faut commencer par une mise  jour!
    goto maj;

    while(1)        {
        //Cette petite manipulation permet de ne rcuprer que les touches qui viennent d'tre prsses (de passer  1)
        TOUCHES=(REG_TOUCHES)&~ancienRegTouches;
        ancienRegTouches=REG_TOUCHES;
        if (TOUCHES)
            repete=0;                       //Changement de touche -> dsactive la rptition pour le moment
        else
            repete++;                       //Aucun changement de touche? Si a continue, on enclenchera la rptition des touches
        if (repete>30 && repete%8==0)
            TOUCHES=REG_TOUCHES&0x03f0;

        if (ev->fonction)       {
            i=(int)ev->fonction(DEM_GESTION,nEv,TOUCHES);
            if (i==0)
                goto maj;
            else if (i==2)
                goto boutonB;
        }
        
        //Si au moins une touche a t appuye, cela vaut la peine de mettre  jour l'affichage, autrement mieux vaut ne pas trop se fatiguer...
        if (TOUCHES)            {
            if (TOUCHES&TOUCHE_BAS)     {
                nEv++;
                JoueSon("curs1.son");
            }
            else if (TOUCHES&TOUCHE_HAUT)       {
                JoueSon("curs1.son");
                nEv--;
            }
            else if (TOUCHES&TOUCHE_A)          {
                //Lit le texte associ au lien slectionn
                if (liens[nEv].symbole[0]==0)     {                 //Pas de lien dfini -> on demande une action au handler
                    i=(int)ev->fonction(DEM_ACTION,nEv,TOUCHES);
                    if (i==0)
                        goto maj;
                    else if (i==2)
                        goto boutonB;
                }
                else    {
                    JoueSon("curs2.son");
                    LTMain(liens[nEv].symbole);
                    lastnEv=nEv;
                    //Mise  jour ncessaire
                    return 1;
                }
            }
            else if (TOUCHES&TOUCHE_B)          {
                JoueSon("curs3.son");
boutonB:
                //Pas de mise  jour requise
                return 0;
            }

            //Vu l'implmentation du modulo sur cette version de GCC, je ne peux pas l'utiliser pour les nombres ngatifs.
            //Si le curseur est tout en bas -> tout en haut.
            while(nEv<0)                nEv+=nEvenement;
            while(nEv>=nEvenement)      nEv-=nEvenement;

maj:
            //Met  jour l'afficheur de texte en fonction de la slection actuelle
            DessineInfo(ev,nEv);
            activite_message=message_fond[0];
        }

        //Selon que c'est un petit mouvement habituel (dplacement vertical) ou le mouvement de dpart de la main, la vitesse de dplacement ne sera pas la mme
        if (BougeMain(c->no_sprite,endroit_x-25,endroit_y+liens[nEv].y-3-gblOffset+(liens[nEv].yfin-liens[nEv].y)/2,bien_place?2:8))
            bien_place=TRUE;

        ChangeFonte(Arial);
        SelectZoneTexte(&zt_debug);

        if (message_fond[0])      {
            //Vide la zone de texte qui affiche le message d'info
            MemSet((void*)&zero,(void*)buffer_debug,30*2*8,DMA_32im);
            //Dessine le texte
            DessTexte(0,0,message_fond,5);
            //Pour ne le dessiner qu'une seule fois;
            message_fond[0]=0;
        }
        
        //Les tches ci-dessous ne doivent pas interfrer avec le balayage de l'cran
        AttendVSync();
        PlaceMiniMessage(activite_message);
        //Copie des sprites
        CopieDMA0(MonOAM,pOAM,1024>>2,DMA_32im);
        //Effets de palette principaux
        Main_EffetsPalette();
        //Prochaine image
        nFrame++;

        //Copie du texte d'informations
        CopieDMA((void*)buffer_infos,(void*)CharBaseBlock(2)+32,16*16*10,DMA_16im);
        CopieDMA((void*)buffer_debug,(void*)CharBaseBlock(3)+32,sizeof(buffer_debug)>>1,DMA_16im);
        //Remet l'cran au jour s'il est  l'tat "nuit".
        FadeOut();
    }
}


